#1729 closed enhancement (fixed)

SMP Step #2

Reported by: Jennifer Averett Owned by: Joel Sherrill
Priority: normal Milestone: 4.11
Component: score Version: 4.11
Severity: minor Keywords:
Cc: ralf.corsepius@…, sebastian.huber@…, gedare@… Blocked By:
Blocking:

Description

This patch contains the next step on the path to SMP support. It adds an allocated array of the Per_CPU structures to support multiple cpus vs a single instance of the structure which is still used if SMP support is disabled. Configuration support was added to explicitly enable or disable SMP. But SMP can only be enabled for the CPUs which will support it initially -- SPARC and i386.

Stub BSP support for SMP was added which lets us treat a single CPU system as a single core SMP from an RTEMS data structure standpoint. This lets us verify that we can allocate a array of one per CPU structures, create one IDLE task, etc.

The i386 and sparc bsps are modified to be able to run when configured as SMP using the stub BSP support.

The NEXT patch adds "real" SMP BSP support for the pc386 and LEON3 BSPs. But since there is not an SMP aware scheduler yet, it is only exercised by test programs which verify we can bring cores 2-n out of reset and initialize them. We have to have an SMP aware scheduler to have tasks scheduled on those cores.

Attachments (8)

smp-Patch.diff (63.6 KB) - added by Jennifer Averett on Jan 7, 2011 at 6:09:30 PM.
Patch to add SMP single core support. This should be used in conjunction with the tar ball that has the added smp directories.
smp-Patch-files.tar.bz2 (10.8 KB) - added by Jennifer Averett on Jan 7, 2011 at 6:11:11 PM.
The smp directories that should be added with the SMP Single Core patch.
smp2_02.tar.bz2 (3.6 KB) - added by Jennifer Averett on Jan 27, 2011 at 6:27:52 PM.
Patch to add SMP single core support.
smp2_02.tar_v1.bz2 (3.6 KB) - added by Jennifer Averett on Jan 27, 2011 at 6:30:01 PM.
smp directories to add with the SMP Single Core Patch.
smp2_02.diff (138.4 KB) - added by Jennifer Averett on Jan 27, 2011 at 6:39:17 PM.
Patch to add SMP single core support.
smp2_03.diff (101.2 KB) - added by Jennifer Averett on Feb 2, 2011 at 2:09:50 PM.
Consolidated and cleaned up patch for Support SMP Single Core
smp2_04.diff (100.8 KB) - added by Jennifer Averett on Feb 11, 2011 at 7:03:33 PM.
SMP Patch with suggested modifications
smp2_05.diff (97.7 KB) - added by Jennifer Averett on Mar 9, 2011 at 5:09:24 PM.
SMP Patch

Download all attachments as: .zip

Change History (21)

Changed on Jan 7, 2011 at 6:09:30 PM by Jennifer Averett

Attachment: smp-Patch.diff added

Patch to add SMP single core support. This should be used in conjunction with the tar ball that has the added smp directories.

Changed on Jan 7, 2011 at 6:11:11 PM by Jennifer Averett

Attachment: smp-Patch-files.tar.bz2 added

The smp directories that should be added with the SMP Single Core patch.

comment:1 Changed on Jan 7, 2011 at 6:11:37 PM by Jennifer Averett

attachments.ispatch: 01
attachments.mimetype: application/octet-streamtext/plain

comment:2 Changed on Jan 21, 2011 at 3:26:45 PM by Sebastian Huber

Cc: Sebastian Huber added
dependson: 1607

comment:3 Changed on Jan 26, 2011 at 7:37:41 PM by Gedare Bloom

Cc: giddyup44@… added

Changed on Jan 27, 2011 at 6:27:52 PM by Jennifer Averett

Attachment: smp2_02.tar.bz2 added

Patch to add SMP single core support.

comment:4 Changed on Jan 27, 2011 at 6:27:52 PM by Jennifer Averett

attachments.isobsolete: 01

Changed on Jan 27, 2011 at 6:30:01 PM by Jennifer Averett

Attachment: smp2_02.tar_v1.bz2 added

smp directories to add with the SMP Single Core Patch.

comment:5 Changed on Jan 27, 2011 at 6:30:01 PM by Jennifer Averett

attachments.isobsolete: 01

Changed on Jan 27, 2011 at 6:39:17 PM by Jennifer Averett

Attachment: smp2_02.diff added

Patch to add SMP single core support.

comment:6 Changed on Jan 27, 2011 at 6:39:17 PM by Jennifer Averett

attachments.isobsolete: 01

comment:7 Changed on Jan 27, 2011 at 6:40:42 PM by Jennifer Averett

attachments.ispatch: 01

Changed on Feb 2, 2011 at 2:09:50 PM by Jennifer Averett

Attachment: smp2_03.diff added

Consolidated and cleaned up patch for Support SMP Single Core

comment:8 Changed on Feb 2, 2011 at 2:09:50 PM by Jennifer Averett

attachments.isobsolete: 01, 1

Changed on Feb 11, 2011 at 7:03:33 PM by Jennifer Averett

Attachment: smp2_04.diff added

SMP Patch with suggested modifications

comment:9 Changed on Feb 11, 2011 at 7:03:33 PM by Jennifer Averett

attachments.isobsolete: 01

comment:10 Changed on Feb 23, 2011 at 10:47:51 AM by Ralf Corsepius

Cc: Ralf Corsepius added

Changed on Mar 9, 2011 at 5:09:24 PM by Jennifer Averett

Attachment: smp2_05.diff added

SMP Patch

comment:11 Changed on Mar 9, 2011 at 5:09:24 PM by Jennifer Averett

attachments.isobsolete: 01

comment:12 Changed on Apr 4, 2011 at 3:48:02 PM by Joel Sherrill

Resolution: fixed
Status: newclosed

Patch committed.

comment:13 Changed on Nov 24, 2014 at 6:58:28 PM by Gedare Bloom

Version: HEAD4.11

Replace Version=HEAD with Version=4.11 for the tickets with Milestone >= 4.11

Note: See TracTickets for help on using tickets.